<?php if (!defined('APPLICATION')) exit();

class MetaTagModel extends Gdn_Model{
	
	public function __construct(){
		parent::__construct('MetaTag'); 
	}
	
	public function Save($FormValues, $Settings = False){
		$this->DefineSchema();
		if(!$this->Validate($FormValues, False)) return False;

		$Fields = $this->Validation->ValidationFields();
		if(!ArrayValue('Language', $Fields)) $Fields['Language'] = ArrayValue('CurrentLanguage', $Settings, 'en');
		
		$Result = ArrayValue('Route', $Fields);
		$Where = array('Route' => $Result, 'Language' => $Fields['Language']);
		
		$Count = $this->GetCount($Where);

		$Save = ($Count == 0) ? $this->Insert($Fields) : $this->Update($Fields, $Where);
		if($Save === False) return False;
		
		return $Result;
	}
	
	public function GetRoute($Route, $Language = False){
		if($Language == False) $Language = MetaTagsPlugin::GetCurrentLanguage();
		$Result = $this->SQL
			->Select()
			->From('MetaTag')
			->Where('Route', $Route)
			->Where('Language', $Language)
			->Get()
			->FirstRow();
		return $Result;
	}
	
}

?>