<?php if (!defined('APPLICATION')) exit();

$PluginInfo['MetaTags'] = array(
	'Name' => 'Meta tags',
	'Date' => '19 Mar 2010',
	'Description' => 'Incompleted Meta tags…',
	'Author' => 'Mr. White',
	'Version' => '0.04',
//	'RegisterPermissions' => array('Plugins.Garden.MetaTags.Manage'), Garden.Settings.Manage
);

class MetaTagsPlugin implements Gdn_IPlugin{
	
	public function __construct(){
		Gdn::FactoryInstall('MetaTag', 'MetaTagModel', dirname(__FILE__) . DS . 'class.metatagmodel.php', Gdn::FactorySingleton);
	}
	
	public function Base_GetAppSettingsMenuItems_Handler(&$Sender){
		$Menu =& $Sender->EventArguments['SideMenu'];
		$Menu->AddLink('Dashboard', Gdn::Translate('Meta tags'), 'garden/settings/metatags', 'Garden.Settings.Manage');
	}
	
	public function SettingsController_MetaTags_Create($Sender){
		$Sender->Permission('Garden.Settings.Manage');
		$Sender->AddSideMenu('garden/settings/metatag');
		// todo: collect all methods
		$MetaModel = Gdn::Factory('MetaTag');
		$Sender->MetaDataSet = $MetaModel->Get();
		$Sender->View = dirname(__FILE__).DS.'view.metatags.php';
		$Sender->Render();
	}
	
	public function SettingsController_MetaTag_Create($Sender){
		
		$Sender->Permission('Garden.Settings.Manage');
		
		$Sender->AddSideMenu('garden/settings/metatag');
		$MetaTag = Gdn::Factory('MetaTag');
		
		$RequestArgs = array_map('strtolower', $Sender->RequestArgs);
		$Route = implode('/', $RequestArgs);
		
		$TagData = $MetaTag->GetRoute($Route);
		$Sender->EditingMetaTag = ($TagData != False);

		if($TagData == False) $TagData = array('Route' => $Route);
		$Sender->Form->SetModel($MetaTag, $TagData);
		
		$Sender->CurrentLanguage = self::GetCurrentLanguage();
		
		if($Sender->Form->AuthenticatedPostBack() != False){
			if($Sender->Form->ButtonExists('Save') !== False){
				$Settings['CurrentLanguage'] = $Sender->CurrentLanguage;
				$Saved = $Sender->Form->Save($Settings);
				if($Saved !== False) $Sender->StatusMessage = Gdn::Translate('Your changes have been saved.');
			}
		}
		
		$LocaleNames = Gdn::Locale()->GetAvailableLocaleSources();
		$Sender->Languages = array_map(array('self', 'LanguageMapCallback'), $LocaleNames);
		$Sender->Languages = array_combine($Sender->Languages, $Sender->Languages);

		$Sender->View = dirname(__FILE__).DS.'view.metatag.php';
		$Sender->Render();
	}
	
	public static function GetCurrentLanguage(){
		return self::LanguageMapCallback(Gdn::Locale()->Current());
	}
	
	protected static function LanguageMapCallback($A){
		return ArrayValue(0, explode('-', $A));
	}
	
	// === NEW METHODS FOR HEADMODULE ===
	public function HeadModule_MetaDescription_Create(&$Head){
		$Head->MetaContent('description', ArrayValue(0, $Head->EventArguments));
	}
	
	public function HeadModule_MetaKeywords_Create(&$Head){
		$Head->MetaContent('keywords', ArrayValue(0, $Head->EventArguments));
	}
	
	public function HeadModule_MetaRobots_Create(&$Head){
		$Head->MetaContent('robots', ArrayValue(0, $Head->EventArguments, 'index, follow'));
	}
	
	public function HeadModule_MetaContent_Create($Head){
		$Name = ArrayValue(0, $Head->EventArguments);
		$Content = ArrayValue(1, $Head->EventArguments);
		$Head->AddTag('meta', array('name' => $Name, 'content' => $Content));
	}
	
	public function HeadModule_MetaClear_Create($Head){
		$Head->ClearTag('meta');
	}
	
	// SET META TAGS INTO HEAD
	public function Base_Render_Before(&$Sender){
		
		if(!$Sender->Head) return;
		d($Sender);

		$MetaModel = Gdn::Factory('MetaTag');
		
		//$Url = $Sender->SelfUrl;
		
		$ControllerName = $Sender->ControllerName;
		if (strtolower(substr($ControllerName, -10, 10)) == 'controller')
			$ControllerName = substr($ControllerName, 0, -10);
		$Url = strtolower($ControllerName . '/' . $Sender->RequestMethod);
		
		$MetaData = $MetaModel->GetRoute($Url);
		if($MetaData === False) return;
		
		$Sender->Head->MetaClear();
		
		if($MetaData->Title != '') $Sender->Title($MetaData->Title);
		
		$Property = array('Description', 'Keywords', 'Robots');
		/* for example, if $Sender (Controller) has property MetaContentDescription
		we will use this value */
		for($i = 0; $i < Count($Property); $i++){
			$PropertyName = $Property[$i];
			$PropertyValue = ObjectValue('MetaContent'.$PropertyName, $Sender);
			if($PropertyValue != False)
				if(!ObjectValue($PropertyName, $MetaData)) $MetaData->$PropertyName = $PropertyValue;
		}

		if($MetaData->Description != '') $Sender->Head->MetaDescription($MetaData->Description);
		if($MetaData->Keywords != '') $Sender->Head->MetaKeywords($MetaData->Keywords);
		if($MetaData->Robots != '') $Sender->Head->MetaRobots($MetaData->Robots);
		
	}
	
	public function Setup(){
		$Result = Gdn::Structure()
			->Table('MetaTag')
			->Column('Route', 'varchar(80)', False, 'primary')
			->Column('Language', 'char(2)', True, 'primary') // need this?
			->Column('Title', 'varchar(200)', True)
			->Column('Keywords', 'varchar(500)', True)
			->Column('Description', 'varchar(500)', True)
			->Column('Robots', 'varchar(80)', True)
			->Set(False, False);
		
		$Default = Gdn::Config('Routes.DefaultController');
		$Model = Gdn::Factory('MetaTag');
		$Count = $Model->GetCount();
		if($Count == 0){
			$Fields = array('Route' => $Default, 'Language' => self::GetCurrentLanguage());
			$Model->Save($Fields);
		}
		return $Result;
	}
}
